<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Attachment_table extends Base_table {

	function __construct()
	{
        parent::__construct(array('tbl'=>'attachment', 'tbl_key'=>'attachment_id'));
	}
	
	public function formatdata(&$data) 
	{
		$data['entity_id']		= $this->entity_id;
		$data['posted_by']		= $this->user_id;
		$data['posted_date']	= $this->cur_time;
				
        return true;
    }
    
    public function save($data)
    {
    	if ($attachment_id = parent::save($data))
    	{
    		// trigger comment notification
    		$pre_data				= $data;
    		$pre_data['attachment_id'] = $attachment_id;
    		$pre_data['user_id'] 	= $this->user_id;
    		$pre_data['entity_id']	= $this->entity_id;
			$pre_data['task_url'] 	= site_url('tasks');
			$pre_data['project_url'] = site_url('project');

    		run_background_process("newAttachmentEvent", json_encode($pre_data));

    		return $attachment_id;
    	}
    
    	return false;
    }
}
/* end of attchment_table.php */
