<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

require_once(FCPATH . '/application/libraries/base_table.php');

class Entity_users_table extends Base_table {
	
	var $act_mcontent = ''; 
	
	function __construct()
	{
        parent::__construct(array('tbl'=>'entity_users', 'tbl_key'=>'user_id'));
	}
	
	public function formatdata(&$data)
	{
		$user = $this->CI->session->userdata('user');
		
		if (!$this->CI->ot_app->get('entity_id') && $this->CI->config->item('SMX_signup_with_autologin'))
		{
			$data['is_active']	= 1;
		}

		if ($user)
		{
			if (empty($data[$this->tbl_key]))
			{
				$data['password']		= !empty($data['password'])?$data['password']:$this->CI->auth->get_random_password();
				$data['is_active']		= !empty($data['is_active'])?$data['is_active']:0;
				
				// activation mail preparation
				if (empty($data['is_active']))
				{
					
				}
			}
		} else {
			$data['created_by']		= -1;
			$data['created_date']	= $this->cur_time;
		}

		// 	encrypt password
        if (!empty($data['password'])) {            
            $data['password'] = $this->CI->auth->encode($data['password']);
        }	else {
			if (isset($data['password'])) unset($data['password']);
			if (isset($data['confirm_password'])) unset($data['confirm_password']);
		}
        
		// check first & last name exists if not get it from username
		if (!isset($data['first_name']) && !isset($data['last_name']) && !empty($data['user_name']))
		{
			$user_name 			= explode(' ',$data['user_name']);
			$data['first_name'] = $user_name[0];
			unset($user_name[0]);
			$data['last_name'] = implode(' ',$user_name);
		}
		$data['user_image']	= isset($data['user_image'])?$data['user_image']:'';
        return true;
    }

	public function save($data)
	{
		$values = $data;
		$sendpwd = false;
		$user = $this->CI->session->userdata('user');

		$user_id = !empty($data[$this->tbl_key])?$data[$this->tbl_key]:0;

		if (!license_limit($user_id, 'users')) {
			$this->CI->response->error(sprintf(lang('UPGRADE_YOUR_VERSION'),'users'));
			return false;
		}

		// check valid user role
		if ($user && !empty($data['user_role']))
		{
			$invalid_role = true;
			$this->CI->load->model('users');
			$roles = $this->CI->users->get_user_roles();
			if (!empty($data['user_id']) && $this->CI->ot_user->get('user_id')==$data['user_id']) {
					$roles[$this->CI->ot_user->get('user_role')] = '';
			}
			if (!$roles || in_array($data['user_role'], array_keys($roles))) {
				$invalid_role = false;
			}

			if ($invalid_role) {
				$this->CI->response->error('USER_ROLE_INVALID');
				return false;
			}
		}

		if(!isset($values['password']))
			$sendpwd = true;
			
			$password = "";
		if (empty($data[$this->tbl_key]))
			{
				$password = $values['password'] = !empty($values['password'])?$values['password']:$this->CI->auth->get_random_password();
				$values['is_active']		= !empty($values['is_active'])?$values['is_active']:0;
			}

		$user_id = parent::save($values);
		
		if (!empty($data['desktop_signup'])) {
			return $user_id;
		}
		if ($user && $user['user_id']==$user_id)
		{
			$this->CI->load->model('user');
			$this->CI->session->set_userdata('user', $this->CI->user->get_user_data($user_id));
		}

		$login_user	= $this->CI->ot_user->get('user_id');

		$from['name']	= $this->CI->config->item('domain_name');
		$from['email']	= $this->CI->config->item('smtp_user');

		if($login_user)
		{
			$this->CI->load->model('entity');
			// $from = $this->CI->entity->get_entity_admin('eu.first_name as name, eu.email as email');
			$company = $this->CI->entity->get_company();
			$sub = lang("USER_ACCOUNT_DETAILS");
			$msg = sprintf(lang("USER_ACCOUNT_TEMPLATE"), $data['first_name'], site_url(), $data['email'], $password, $from['name'], $company['company_name']);
		//}
		/*else
		{
			$sub	= lang("ENTITY_REGISTERED");
			$msg	= sprintf(lang("ENTITY_REGISTER_TEMPLATE"), $data['user_name'], $this->CI->config->item('protocal').$data['domain_url'], $data['email'], $password);
//			$fromMail	= $this->CI->config->item('ot_email_from');
		}*/

			if (empty($data[$this->tbl_key]))
			{
	
				$result	= $this->CI->db->insert('user_mails', array(
						'entity_id'	=> !empty($this->entity_id)?$this->entity_id:$data['entity_id'],
						'user_id'	=> $user_id,
						'mail_type'	=> 'WS',
						'is_subscribed'	=> 1
					));
	
				if($values['is_active'])
				{
					$this->CI->load->library('email');
					$email_config = array(
					    'mailtype'	=> 'html',
					    'charset'	=> 'utf-8'
					);
					$this->CI->email->initialize($email_config);
			        $email	= $this->CI->email;
			        $email->clear();
			        $email->to($data['email']);
			        $email->from($from['email'], $from['name']);
			        $email->subject($sub);
			        $email->message(nl2br($msg));		        
					if (!$email->send())
					{
						$this->error	= $email->print_debugger();
		// 				return false;
					}
				}
			}
		}
		
		if ($user_id)
		{
			return $user_id;
		}

		return $user_id;
	}

	function reset_password($toemail) 
	{
		$db						= $this->CI->db;
        $session				= $this->CI->session;
		$db->select('user_id,is_active,first_name');
        $query = $db->get_where($this->tbl, array('email' => $toemail, 'entity_id' => $this->entity_id));
        if (!$query->num_rows()) {
            $this->error = lang('ERROR_RESET_INVALID_EMAIL');
            return false;
        }

        $user = $query->row_array();

        if (!$user["is_active"]) {
            $this->error = lang('ERROR_RESET_NOT_ACTIVATED');
            return false;
        }

        $token = $this->CI->auth->get_random_password(16);
        $values['activation'] = md5($token);
        
		$db->where('user_id' ,$user['user_id']);
        $db->update($this->tbl,$values);
        
        $this->CI->load->model('entity');
//		$from = $this->CI->entity->get_entity_admin('eu.first_name as name, eu.email as email');
		$from['name']	= $this->CI->config->item('domain_name');
		$from['email']	= $this->CI->config->item('smtp_user');

		$company = $this->CI->entity->get_company();
		$reset_link = "<a href='" . site_url('user/reset/reset_password') . "'>".site_url('user/reset/reset_password')."</a>";
		$msg = sprintf(lang("RESET_PASSWORD_MAIL_SENT"), $user['first_name'], $values['activation'], $reset_link);

		$this->CI->load->library('email');
		$email_config = array(
		    'mailtype'    => 'html',
		    'charset'    => 'utf-8'
		);				
		$this->CI->email->initialize($email_config);	
        $email = $this->CI->email;
        $email->clear();
        $email->to($toemail);
        $email->from($from['email'],$from['name']);
        $email->subject(lang("PASSWORD_RESET_REQUEST_SENT"));
        $email->message(nl2br($msg));
		
        if (!$email->send())
		{			
			$this->error = $email->print_debugger();
			return false;
		}
        return true;
	}
	function reset_confirm() 
	{
		$db 		= $this->CI->db;
        $session 	= $this->CI->session;
        $input 		= $this->CI->input;

        $query = $db->get_where($this->tbl, array('email' => $input->post("email"), 'entity_id' => $this->entity_id));
        if (!$query->num_rows()) {
            $this->error = $lang('ERROR_RESET_CONFIRM');
            return false;
        }

        $user = $query->row_array();

        if ($user["activation"] != $input->post("verification_code")) {
            $this->error = lang('ERROR_RESET_VERIFICATION_INVALID');
            return false;
        }

        if (!$user["is_active"]) {
            $this->error = lang('ERROR_RESET_USER_BLOCKED');
            return false;
        }
		$user['password']='';
		$user['activation']='';
        $session->set_userdata('reset.user',$user);
        return true;
	}
 	function reset_complete() {
        $db = $this->CI->db;

        $user = $this->CI->session->userdata('reset.user');
		$user['password'] = $this->CI->input->post("password");

        if (!parent::save($user)) {
			return false;
		}
        return true;
    }
}

/* end of entity_users_table.php*/
