<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

class Report_member extends CI_Model {
	
	function __construct()
	{
        parent::__construct();
        $this->load->model('client');
		$this->load->model('project');
	}
	
	public function get_report_settings($report_code)
	{
		$query = $this->db->get_where('user_report_settings',array('entity_id' => $this->ot_app->get('entity_id'), 'user_id' => $this->ot_user->get('user_id'), 'report_code' => $report_code));
		$result = $query->row_array();

		return $result;
	}
	
	public function get_team_users($data)
	{
		return array();
	}
	
	public function get_items($data, $select)
	{
		$data['users_where_in'] = $this->get_team_users($data);
		
		if($data['report_code']!='IS') 
		{
			/*$diff = abs(strtotime($data['filters']['to_date']) - strtotime($data['filters']['from_date']));
			$diff_days = floor($diff/ (60*60*24));
			if (isset($select[REP_PERIOD]) && $diff_days >=31)
			{
				$select[REP_PERIOD][0] = str_replace('%Y-%m-%d', '%b', $select[REP_PERIOD][0]);
			}
	
			if (isset($select[REP_EXPENSE_PERIOD]) && $diff_days >=31)
			{
				$select[REP_EXPENSE_PERIOD][0] = str_replace('%Y-%m-%d', '%b', $select[REP_EXPENSE_PERIOD][0]);
			}*/
			if($data['report_code']==REPORT_TASK_DETAIL && !empty($select[REP_TASK_TYPE])) {
					$this->db->select('pt.task_type_id');
			}
			if($data['report_code']==REPORT_TASK_SUMMARY) {
				foreach ($select as $key => $val) {
					if($key==REP_HOURS) {
						$this->db->select('pt.task_id', false);
					} else {
						$this->db->select($val[0], false);
					}
				}
			} else {
				foreach ($select as $key => $val) {
					$this->db->select($val[0], false);
				}
			}
		}
		
		$this->set_items_where($data, $select);
		$group_by		= !empty($data['group_by']) ? $data['group_by']:REP_PERIOD;
				
		$query = $this->db->get();
		//echo $this->db->last_query();
		$result['items'] = $query->result_array();

		if ($result['items']) 
		{
			switch($data['report_code']) 
			{
				case REPORT_TIME_DETAIL:
					$tmp = $result['items'];
					$time_sheet_ids = $result['items'] = array();
					
					foreach ($tmp as $row)
					{
						if (!empty($select[REP_START_AND_END_TIME]))
							$time_sheet_ids[] = $row[REP_START_AND_END_TIME];
							
						$key = $row[$group_by];
						$result['details'][$key][] = $row;
						foreach ($row as $rkey => $val)
						{
							if (isset($select[$rkey][1]) && $select[$rkey][1] == 'N') {
								$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
							} else if ($group_by==$rkey) {
								$result['items'][$key][$rkey] = $val;
							}
						}
					}
					if ($time_sheet_ids) {
						$this->load->model('timesheets');
						$time_details = $this->timesheets->get_details($time_sheet_ids, 'td.time_sheet_id,td.from_time, td.to_time');
						
						if ($time_details) {
							foreach ($time_details as $row)
							{
								$result['time_details'][$row['time_sheet_id']][] = array(date('H:i',strtotime($row['from_time'])),date('H:i',strtotime($row['to_time']))); 
							}
						}
					}
				break;
				case REPORT_TIME_SUMMARY:
					$tmp = $result['items'];
					$result['items'] = array();
					
					$g_map = $this->report_lib->get_detail_group_by($data);
					if (isset($g_map[$group_by])) {
						$group_key = 'gpby';
					}
					foreach ($tmp as $row)
					{
						$key = (isset($group_key))?$row[$group_key]:$row[$group_by];
						foreach ($row as $rkey => $val)
						{
							if (isset($select[$rkey][1]) && $select[$rkey][1] == 'N') {
								$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
							} else {
								$result['items'][$key][$rkey] = $val;
							}
						}
					}
					if(!empty($result['items'])) {
						$this->db->select('sum(ts.hours * ts.is_billable ) AS billable, sum(ts.hours * ! ts.is_billable ) AS non_billable');
						$result['chart'] = $this->get_totals($data);
					}
				break;		
				case REPORT_TASK_SUMMARY:
					if (!empty($select[REP_HOURS]) && !empty($result['items'])) {
						$items = array();
						foreach ($result['items'] as $item) {
							$items[$item['detail_filter']] = $item;
						}
						$this->db->select($select[REP_HOURS][0].', project_task_id', false);
						$this->db->from('time_sheet AS ts');
						$this->db->where(array('entity_id' => $this->ot_app->get('entity_id'), 'project_task_id >'=> 0 , 'entry_date >=' => $data['filters']['from_date'], 'entry_date <=' => $data['filters']['to_date']));
						if ($data['filters']['US'][0]!='all') {
							$this->db->where_in('ts.user_id', $data['filters']['US']);
						}
						if (is_member()) {
							$this->db->where('ts.user_id', $this->ot_user->get('user_id'));
						}
						$query = $this->db->group_by('project_task_id')->get();
						$ts_totals = $query->result_array();

						if ($ts_totals) {
							foreach ($ts_totals as $row) {
								if (!empty($items[$row['project_task_id']])) {
										$items[$row['project_task_id']][REP_HOURS] = $row[REP_HOURS];
								}
							}
							$result['items'] = array_values($items);
						}
					}
				case REPORT_TASK_DETAIL:
					if ($data['report_code']==REPORT_TASK_DETAIL && $result['items']) {
						$this->load->model('entity');
						$tmp_task_types = $this->entity->get_task_types('task_type_id, name');
						$task_types = array();

						foreach ($tmp_task_types as $tt) {
							$task_types[$tt['task_type_id']] = $tt['name'];
						}
						$tmp_items = $result['items'];
						$result['items'] = array();
						foreach ($tmp_items as $row) {
							$key =$row['detail_filter'];
							if (!isset($result['items'][$key])) {
								$result['items'][$key] = array();
							}
							$result['details'][$key][] = $row;
							foreach ($row as $rkey => $val)
							{
								if (isset($select[$rkey][1]) && $select[$rkey][1] == 'N') {
									$result['items'][$key][$rkey] = isset($result['items'][$key][$rkey])? ($result['items'][$key][$rkey]+$val): $val;
								} 
								switch ($rkey) {
									case REP_STATUS_BGCOLOR:
									case REP_STATUS_TEXT_COLOR:
									case REP_PROJECT_TASK:
										$result['items'][$key][$rkey] = $val;
									break;
									case 'task_type_id':
										$result['items'][$key][REP_TASK_TYPE] = $task_types[$val];
									break;
									case REP_PERIOD:
										$result['items'][$key][$rkey] = $row[REP_STATUS];
									break;
								}
							}
						}
					}
					$result['chart'] = $this->get_totals($data);
				break; 	
				break;
			}
		}		
		return $result; 
	}

	public function set_items_where ($data, $select = array())
	{
		$filters = array();

		if (!empty($data['group_by'])) {
			switch($data['group_by'])
			{
				case REP_PERIOD:
					$detail_filter = "DATE_FORMAT(ts.entry_date,'%Y-%m-%d') AS detail_filter";
					break;
				case REP_PROJECT:
					$detail_filter = "pr.project_id AS detail_filter";
					break;
				case REP_CLIENT:
					$detail_filter = "cl.client_id AS detail_filter";
				break;
				case REP_TASK_TYPE:
					$detail_filter = "ty.task_type_id AS detail_filter";
				break;
				case REP_USER:
					$detail_filter = "eu.user_id AS detail_filter";
				break;
				case REP_EXPENSE_CATEGORY:
					$detail_filter = "ey.expense_type_id AS detail_filter";
				break;
				case REP_EXPENSE_PERIOD:
					$detail_filter = "DATE_FORMAT(pe.expense_date,'%Y-%m-%d') AS detail_filter";
				break;
				case REP_PROJECT_TASK:
					$detail_filter = "pt.task_id AS detail_filter";
				break;
			}
		
			if(!empty($detail_filter)) {
				$this->db->select($detail_filter, false);
			}
		}
				
		switch($data['report_code']) 
		{
			case REPORT_TIME_DETAIL:
				if (empty($data['chart'])) {
					$result = $this->report_lib->get_detail_group_by($data);			
					if ($result) {
						$tmp_arr = array();
						foreach ($result as $key => $val)
						{
							if (isset($select[$key]) && $select[$key][2])
							{
								$tmp_arr[]= $val;
							}
						}
						$group_by = implode(',', $tmp_arr);
					}
				}
			case REPORT_TIME_SUMMARY:
				$data['filters']['from_date_column']	= 'ts.entry_date';
				$data['filters']['to_date_column']		= 'ts.entry_date';
				$data['filters']['task_type']			= 'ts.task_type_id';
				$data['filters']['users']				= 'ts.user_id';
				$data['list_view']						= !empty($data['list_view'])?$data['list_view']:'date';
				$filters = array('from_date', 'to_date', REP_PROJECT, REP_CLIENT, REP_TASK_TYPE, REP_USER);
				
				$this->get_time_report_query($data, $select);
				
				if (empty($data['chart'])) {
					$g_map = $this->report_lib->get_detail_group_by($data);
					$default_group_by = !empty($data['group_by']) ? $data['group_by']:REP_PERIOD;
					$group_by = !empty($group_by)?$group_by:$default_group_by;
					if (isset($g_map[$group_by])) {
						$this->db->select($g_map[$group_by].' AS gpby');
						$group_by = $g_map[$group_by];
					}
					$this->db->group_by($group_by);
					
					if (!empty($select[REP_PERIOD]) && $default_group_by!=REP_PERIOD) {
						$this->db->order_by($default_group_by.','.REP_PERIOD);
					} else {
						$this->db->order_by($default_group_by);
					}
				}
			break;
			case REPORT_TASK_DETAIL:
				$data['detail'] = true;
				// $data['filters']['from_date_column']	= 'pt.start_date';
				// $data['filters']['to_date_column']		= 'pt.finish_date';
				$data['filters']['task_type']			= 'ts.task_type_id';
				$data['filters']['users']				= 'ts.user_id';
				$data['filters']['task_status']			= 'pt.task_status_id';
				$data['filters']['client_id']			= 'pr.client_id';
				$filters = array('from_date', 'to_date', REP_PROJECT, REP_CLIENT, REP_TASK_TYPE, REP_USER,REP_TASK_STATUS,REP_PROJECT_TASK);
				$this->get_task_detail_report_query($data, $select);
				if (!empty($data['filters']['from_date']) && !empty($data['filters']['to_date'])) {
					$this->db->where("((pt.start_date >='".$data['filters']['from_date']."' AND pt.finish_date<='".$data['filters']['to_date']."') OR (pt.created_date >='".$data['filters']['from_date']."' AND pt.created_date<='".$data['filters']['to_date']."'))", NULL, FALSE);
				} 
				
			break;
			case REPORT_TASK_SUMMARY:
				//$data['filters']['from_date_column']	= 'pt.start_date';
				//$data['filters']['to_date_column']		= 'pt.finish_date';
				$data['filters']['task_type']			= 'pt.task_type_id';
				$data['filters']['users']				= 'ptu.user_id';
				$data['filters']['task_status']			= 'pt.task_status_id';
				$filters = array('from_date', 'to_date', REP_PROJECT, REP_CLIENT, REP_TASK_TYPE, REP_USER,REP_TASK_STATUS);
				$this->get_task_report_query($data, $select);
				if (!empty($data['filters']['from_date']) && !empty($data['filters']['to_date'])) {
					$this->db->where("((pt.start_date >='".$data['filters']['from_date']."' AND pt.finish_date<='".$data['filters']['to_date']."') OR (pt.created_date >='".$data['filters']['from_date']."' AND pt.created_date<='".$data['filters']['to_date']."'))", NULL, FALSE);
				}
			break;
			case REPORT_INVOICE_SUMMARY:
				$data['filters']['from_date_column']	= 'inv.invoice_date';
				$data['filters']['to_date_column']		= 'inv.invoice_date';  
				$data['filters']['invoice_status'] 		= 'inv.status';
				$filters = array('from_date', 'to_date', REP_CLIENT);
				$this->db->select("DATE_FORMAT(inv.invoice_date,'%Y-%m-%d') AS detail_filter" ,false);
				$this->get_invoice_report_query($data, $select);
			break;
			case REPORT_INVOICE_DETAIL:
				$data['filters']['from_date_column']	= 'inv.invoice_date';
				$data['filters']['to_date_column']		= 'inv.invoice_date';
				$data['filters']['invoice_status'] 		= 'inv.status';
				$filters = array('from_date', 'to_date', REP_CLIENT, REP_INVOICE_STATUS);  
				$this->get_invoice_detail_report_query($data, $select);
			break;	
			case REPORT_INVOICE_AGING:
				$filters = array('from_date', 'to_date', REP_CLIENT);
				$this->get_invoice_aging_report_query($data, $select);
			break;	
			case REPORT_INVOICE_OUTSTANDING:
				$filters = array('from_date', 'to_date', REP_CLIENT);
				$this->get_invoice_outstanding_query($data, $select);
			break;	
			case REPORT_INVOICE_UNINVOICED:
				$filters = array('from_date', 'to_date', REP_CLIENT);
				$this->get_invoice_uninvoiced_query($data, $select);
			break;
			case REPORT_INVOICE_UNINVOICED_HOURS_DETAIL:
				$this->get_unapproved_hours_detail_query($data, $select);
			break;
			case REPORT_INVOICE_UNINVOICED_EXPENSE_DETAIL:
				$this->get_unapproved_expense_detail_query($data, $select);
			break;
			case REPORT_BUDGET:
				$filters = array(REP_CLIENT, REP_PROJECT);
				$this->get_budget_query($data, $select);
			break;
			case REPORT_BUDGET_DETAIL:
				$filters = array(REP_CLIENT, REP_PROJECT);
				$this->get_budget_detail_query($data, $select);
			break; 
			
			case REPORT_EXPENSE_DETAIL:
				if (empty($data['chart'])) {
					$result = $this->report_lib->get_detail_group_by($data);			
					if ($result) {
						$tmp_arr = array();
						foreach ($result as $key => $val)
						{
							if (isset($select[$key]) && $select[$key][2])
							{
								$tmp_arr[]= $val;
							}
						}
						$group_by = implode(',', $tmp_arr);
					}
				}
			case REPORT_EXPENSE_SUMMARY:
				$data['filters']['from_date_column']	= 'pe.expense_date';
				$data['filters']['to_date_column']		= 'pe.expense_date';
				$data['filters']['expense_category']	= 'ey.expense_type_id';
				$filters = array('from_date', 'to_date', REP_CLIENT, REP_PROJECT, REP_EXPENSE_CATEGORY, REP_USER);
				$this->get_expense_query($data, $select);
				
				if (empty($data['chart'])) {
					$default_group_by = !empty($data['group_by']) ? $data['group_by']:REP_INVOICE_PERIOD;
					$group_by = !empty($group_by)?$group_by:$default_group_by;
					$this->db->group_by($group_by);
					$this->db->order_by('pe.expense_date');
				}
			break;	
		}			

		if (!empty($data['filters']))
		{
			$where_columns = array(REP_PROJECT => 'pr.project_id', REP_CLIENT => 'cl.client_id', REP_PROJECT_TASK => 'pt.task_id');
			
			if(isset($data['filters']['from_date_column'])) $where_columns['from_date'] = $data['filters']['from_date_column'] . ' >=';
			if(isset($data['filters']['to_date_column'])) $where_columns['to_date'] = $data['filters']['to_date_column'] . ' <=';
			if(isset($data['filters']['users'])) $where_columns[REP_USER] = $data['filters']['users'];
			if(isset($data['filters']['task_type'])) $where_columns[REP_TASK_TYPE] = $data['filters']['task_type'];
			if(isset($data['filters']['invoice_status'])) $where_columns[REP_INVOICE_STATUS] = $data['filters']['invoice_status'];
			if(isset($data['filters']['expense_category'])) $where_columns[REP_EXPENSE_CATEGORY] = $data['filters']['expense_category'];
			if(isset($data['filters']['task_status'])) $where_columns[REP_TASK_STATUS] = $data['filters']['task_status'];
			if(isset($data['filters']['client_id'])) $where_columns[REP_CLIENT] = $data['filters']['client_id'];
/*print_r($data['filters']);
// REP_PROJECT_TASK
exit;*/
			foreach ($filters as $k=>$v)
			{
				$value = isset($data['filters'][$v])?$data['filters'][$v]:'';
				if (isset($where_columns[$v])) {
					if (!is_array($value))
					{
						if ($value!=null)
							$this->db->where($where_columns[$v], $value);
					} else if (!in_array('all', $value) && implode('',$value)) {
						$this->db->where_in($where_columns[$v], $value);
					}
				}
			}
		}

		return true;
	}
	
	function get_time_report_query($data, $select=array())
	{
		if($data['list_view']=='month') {
			$this->db->select("concat(DATE_FORMAT(DATE_FORMAT(ts.entry_date, '%Y-%m-%d'), '%Y-%m-01'), ' - ' ,
        	 LAST_DAY(DATE_FORMAT(ts.entry_date, '%Y-%m-%d'))) as DA ", FALSE);
		}
		else if($data['list_view']=='week') {
			$this->db->select("concat(subdate(DATE_FORMAT(ts.entry_date, '%Y-%m-%d'), INTERVAL weekday(DATE_FORMAT(ts.entry_date, '%Y-%m-%d')) DAY), ' - ',
         adddate(DATE_FORMAT(ts.entry_date, '%Y-%m-%d'), INTERVAL 6-weekday(DATE_FORMAT(ts.entry_date, '%Y-%m-%d')) DAY)) as DA", FALSE);
		}

		$this->db->from('time_sheet as ts');
		$this->db->join('project as pr', 'ts.entity_id=pr.entity_id and pr.project_id=ts.project_id');

		if (!empty($data['group_by']) && $data['group_by'] == REP_CLIENT || !empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'ts.entity_id=cl.entity_id and cl.client_id=pr.client_id');
		if (!empty($data['group_by']) && $data['group_by'] == REP_USER || !empty($select[REP_USER]))	
			$this->db->join('entity_users as eu', 'ts.entity_id=eu.entity_id and eu.user_id=ts.user_id');

		if (!empty($select['TA']))
			$this->db->join('project_task as pt', 'pt.entity_id=ts.entity_id and pt.task_id=ts.project_task_id', 'left');
		$this->db->join('task_type as ty', 'ts.entity_id=ty.entity_id and ts.task_type_id=ty.task_type_id','left');
		$this->db->join('project_task_types as pty', 'ty.entity_id=pty.entity_id and ty.task_type_id=pty.task_type_id AND pty.project_id = pr.project_id','left');
		$this->db->join('project_users as pru', 'ts.entity_id=pru.entity_id and ts.user_id=pru.user_id AND pr.project_id = pru.project_id','left');
		$this->db->where(array('ts.entity_id' => $this->ot_app->get('entity_id'), 'ts.hours >' => 0,'ts.user_id' => $this->ot_user->get('user_id')));
		
//		if (empty($data['chart'])) {
//			if(!empty($data['group_by']))
//				$this->db->group_by($data['group_by']);
//			if ($data['report_code']!='TS')
//				$this->db->group_by('ts.entry_date');
//		} 
		
		return true;
	}

	function get_task_detail_report_query($data, $select)
	{
		$this->db->from('project_task as pt');
		
		$this->db->join('time_sheet as ts', 'ts.project_Task_id=pt.task_id', 'LEFT');

		$where = array('pt.entity_id' => $this->ot_app->get('entity_id'), 'pt.is_parent !=' => 1);
		/*if (!empty($data[REP_PROJECT_TASK])) {
			$where['pt.task_id'] = $data[REP_PROJECT_TASK];
		} else {
			$where['pt.task_id >'] = 0;
		}*/
		$this->db->where($where);
		$this->db->join('project as pr', 'pr.project_id=pt.project_id');
		$this->db->join('task_type as ty', 'ty.entity_id = ts.entity_id and ty.task_type_id=ts.task_type_id','LEFT');
		$this->db->join('task_status as tt', 'tt.entity_id=pt.entity_id and tt.task_status_id=pt.task_status_id','LEFT');
		$this->db->join('entity_users as eu', 'ts.user_id=eu.user_id','LEFT');
		$this->db->group_by('pt.task_id, ts.user_id, ts.task_type_id, ts.entry_date');
		$this->db->order_by('pt.task_id', 'desc');
		return true;
	}

	function get_task_report_query($data, $select)
	{
		$this->db->select('if (tt.is_closed=1 and tt.system_defined, 1, 0) AS is_closed', FALSE);
		$this->db->from('project_task as pt');
		
		$this->db->join('project as pr', 'pr.project_id=pt.project_id');

		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'cl.client_id=pr.client_id');
			
		//if (!empty($select[REP_HOURS]))
		//	$this->db->join('time_sheet as ts', 'ts.project_task_id=pt.task_id');
			
			
		$this->db->join('project_users as pru', 'pr.entity_id=pru.entity_id and pr.project_id = pru.project_id');
		$this->db->join('task_type as ty', 'pt.entity_id = ty.entity_id and pt.task_type_id=ty.task_type_id','LEFT');
		$this->db->join('task_status as tt', 'tt.entity_id=pt.entity_id and tt.task_status_id=pt.task_status_id','LEFT');
		$this->db->join('project_task_users as ptu', 'ptu.task_id=pt.task_id','LEFT');
		$this->db->join('entity_users as eu', 'eu.user_id=ptu.user_id','LEFT');
		$this->db->where(array('pt.entity_id' => $this->ot_app->get('entity_id'), 'pru.user_id' => $this->ot_user->get('user_id'))); 
		$this->db->group_by('pt.task_id');
		$this->db->order_by('pt.task_id', 'desc');

		return true;
	}
 
	/*function get_task_report_query($data, $select)
	{
		$this->db->from('project_task as pt');
		
		$this->db->join('project as pr', 'pr.project_id=pt.project_id');

		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'cl.client_id=pr.client_id');
			
		//if (!empty($select[REP_HOURS]))
		//	$this->db->join('time_sheet as ts', 'ts.project_task_id=pt.task_id');
			
		$this->db->join('project_task_types as pty', 'pty.project_id = pr.project_id AND pty.task_type_id=pt.task_type_id');
		$this->db->join('task_type as ty', 'ty.task_type_id=pty.task_type_id');
		$this->db->join('project_users as pru', 'pru.project_id = pr.project_id');
		$this->db->join('project_task_users as ptu', 'ptu.task_id=pt.task_id');
		$this->db->join('entity_users as eu', 'eu.user_id=ptu.user_id');
		$this->db->join('task_status as tt', 'tt.task_status_id=pt.task_status_id','left');
		$this->db->where(array('pt.entity_id' => $this->ot_app->get('entity_id'), 'pru.user_id' => $this->ot_user->get('user_id'))); 

		return true;
	}*/
	
	public function save($data)
	{
		$data['user_id']	= $this->ot_user->get('user_id');
		$data['entity_id']  = $this->ot_app->get('entity_id');

		$this->db->select('rpt_setting_id');
		$this->db->from('user_report_settings');
		$this->db->where(array('report_code' => $data['report_code'], 'user_id' => $data['user_id'], 'entity_id' => $data['entity_id']));
		
		$query = $this->db->get();
		$result = $query->row_array();
		
		if ($result) {
			$id = $result['rpt_setting_id'];
			$this->db->where(array('rpt_setting_id' => $id));
			$this->db->update('user_report_settings', $data);			
		} else {
			$this->db->insert('user_report_settings', $data);
			$id = $this->db->insert_id();
		}
		
		return $id;;
	} 
	
	public function get_totals ($data)
	{
		$result = array();
		if (!empty($data['group_by'])) unset($data['group_by']);

		switch($data['report_code']) 
		{
			case REPORT_TASK_DETAIL:
				$this->db->select('sum(ts.hours) as hours , ts.user_id, ts.task_type_id, eu.first_name, ty.name as tt_name');
				$data['chart'] = true;
				$this->set_items_where($data);
				$this->db->group_by('ts.user_id, ts.task_type_id');
				$query = $this->db->get();

				$result  = $query->result_array();
				$this->load->model('entity');
				$types = $this->entity->get_task_types('task_type_id, name');

				if ($result) {
					$tmp_result = $result;
					$tmp_types = $result = array();
					foreach ($types as $type) {
						$tmp_types[$type['name']] = array('hours' => 0);
					}
					foreach ($tmp_result as $row) {
						$key = $row['user_id']."__".$row['first_name'];
						if (!isset($result[$key])) {
							$result[$key] = $tmp_types;
						}
						$result[$key][$row['tt_name']] = isset($result[$row['user_id']][$row['tt_name']])?$result[$row['user_id']][$row['tt_name']]:array();
						$result[$key][$row['tt_name']] = array('hours' => $row['hours'], 'first_name' => $row['first_name']);
					}
				}
			break;
			case REPORT_TASK_SUMMARY:
				$this->db->select('pt.task_id, ty.task_type_id, ty.name, tt.name as status_name, tt.bg_color, count(pt.task_status_id) as task_status_count ');
				$this->set_items_where($data);
				$this->db->group_by('pt.task_type_id, pt.task_status_id');
				
				$query = $this->db->get();

				$res  = $query->result_array();
				$result = $bar = $pie = $status = array();
				$total_cnt = 0;

				foreach($res as $key=>$value) { 
					$total_cnt+= $value['task_status_count'];
					/*if(!isset($status[$value['task_type_id']]['total_count']))
						$status[$value['task_type_id']]['total_count'] = 0;
					$status[$value['task_type_id']]['total_count']+=$value['task_status_count'];*/
				}

				$this->load->model('entity');
				$types = $this->entity->get_task_types('task_type_id, name');
				$status = $this->entity->get_task_status();

				foreach ($types as $row) {
					$bar[$row['name']] = array();
					foreach ($status as $s_row) {
						$bar[$row['name']][$s_row['name']] = array('percent' => 0 , 'color' => $s_row['bg_color']);
					}
				}	

				foreach($res as $key=>$value) {
					// Bar chart data
					if(!empty($bar[$value['name']][$value['status_name']]['percent']))
						$bar[$value['name']][$value['status_name']]['percent'] = $bar[$value['name']][$value['status_name']]['percent'] + ($value['task_status_count']/$total_cnt) * 100;
					else {
						$bar[$value['name']][$value['status_name']]['percent']	= ($value['task_status_count']/$total_cnt) * 100;
						$bar[$value['name']][$value['status_name']]['color']	= $value['bg_color'];
					}	 

					// Pie chart data
					if(isset($pie[$value['status_name']]['percent']))
						$pie[$value['status_name']]['percent'] = $pie[$value['status_name']]['percent'] + $bar[$value['name']][$value['status_name']]['percent'];
					else 
						$pie[$value['status_name']]	= $bar[$value['name']][$value['status_name']];	
						
				} 

				$result['piechart'] = $pie;
				$result['barchart']	= $bar;	

			break;
			case REPORT_INVOICE_SUMMARY:
				$this->db->select('inv.amount,inv.payment_amount, inv.due_date', false);
				$select = 'inv.invoice_date';
				$diff = abs(strtotime($data['filters']['to_date']) - strtotime($data['filters']['from_date']));
				$diff_days = floor($diff/ (60*60*24));
				if ($diff_days >=31)
				{
					$select = "DATE_FORMAT(inv.invoice_date, '%b') AS invoice_date";
				}
				$this->db->select($select , false);
				$data['chart'] = true;
				$this->set_items_where($data);
				$this->db->group_by('inv.invoice_id');
				$query = $this->db->get();
				$items  = $query->result_array();

				$cur_date = $this->auth->get_timezone_date('Y-m-d', true);
				foreach($items as $key=>$value) 
				{
					$value['due_amount'] = $value['amount'] - $value['payment_amount'];
										
					$result[$value['invoice_date']]['overdue'] 	= !empty($result[$value['invoice_date']]['overdue'])?($result[$value['invoice_date']]['overdue']):0;
					$result[$value['invoice_date']]['paid'] 	= !empty($result[$value['invoice_date']]['paid'])?($result[$value['invoice_date']]['paid']):0;
					$result[$value['invoice_date']]['due'] 		= !empty($result[$value['invoice_date']]['due'])?($result[$value['invoice_date']]['due']):0;
					
					if ($value['payment_amount'])
					{
						$status = 'paid';
						$result[$value['invoice_date']][$status] += $value['payment_amount'];
					}

					if ($value['due_amount']) {
						$status = (strtotime($cur_date) <= strtotime($value['invoice_date']))?'due':'overdue';
						$result[$value['invoice_date']][$status] += $value['due_amount'];
					}
				}
			break;	
			default:
				$this->db->select('sum(ts.hours * ts.is_billable ) AS billable, sum(ts.hours * ! ts.is_billable ) AS non_billable', false);
				if (is_admin())
					$this->db->select("SUM(ts.hours * ts.invoice_id/ts.invoice_id) AS invoiced, SUM(ts.hours * ! ts.invoice_id * ts.is_billable) AS un_invoiced, sum(ts.hours * (case pr.invoice_type when 'T' then pty.hourly_rate when 'P' then pru.hourly_rate else 0 end) * ts.is_billable) AS amount", false);
				$data['chart'] = true;
				$this->set_items_where($data);
				$query = $this->db->get();
				$result  = $query->row_array();
			break;		
		} 

		return $result;
	}
	function get_expense_query($data, $select)
	{
		$this->db->from('project_expense as pe');
		$this->db->join('project as pr', 'pr.project_id=pe.project_id');
		
		if (!empty($select[REP_CLIENT]) || !empty($data['filters'][REP_CLIENT]))
			$this->db->join('client as cl', 'cl.client_id=pr.client_id');
		if (!empty($select[REP_USER]))	
			$this->db->join('entity_users as eu', 'eu.user_id=pe.created_by');
			
		$this->db->join('expense_type as ey', 'ey.expense_type_id=pe.expense_type_id');
		$this->db->join('project_users as pru', 'pe.entity_id=pru.entity_id and pe.created_by=pru.user_id AND pru.project_id = pr.project_id');
		$this->db->where(array('pe.entity_id' => $this->ot_app->get('entity_id'),'pru.user_id' => $this->ot_user->get('user_id')));

		return true;
	}
	function get_currency($currency_code) 
	{
		$this->db->select('currency_symbol');
		$this->db->from('currency');
		$this->db->where('currency_code', $currency_code);
		$query = $this->db->get();
		$result = $query->row_array();
		return isset($result['currency_symbol'])?$result['currency_symbol']:'';	
	}
	
	public function get_projects($params) {
		$result = array();
		
		$app_filter = false;
		//if ($params['filters']) {
			$filters = !empty($params['filters'])?$params['filters']:array(); 
			$where = array('pr.entity_id' => $this->ot_app->get('entity_id'));
			$this->db->select('DISTINCT pr.project_id, concat(pr.project_code,pr.project_name) as project_name', FALSE);
			$this->db->from('project AS pr');

			if (!empty($filters[REP_CLIENT]) && $filters[REP_CLIENT][0]!='all') {
				$this->db->where_in('pr.client_id',$filters[REP_CLIENT]);
				$app_filter = true;
			}
			if (!empty($filters[REP_USER]) && $filters[REP_USER][0]!='all') {
				$this->db->join('project_users AS pru','pr.project_id = pru.project_id');
				$this->db->where_in('pru.user_id',$filters[REP_USER]);
				$app_filter = true;
			}
			if (!empty($filters[REP_TASK_TYPE]) && $filters[REP_TASK_TYPE][0]!='all') {
				$this->db->join('project_task_types AS ptt','pr.project_id = ptt.project_id');
				$this->db->where_in('ptt.task_type_id',$filters[REP_TASK_TYPE]);
				$app_filter = true;
			}
			
			$this->db->where($where);
			$this->db->order_by('pr.project_name','asc');
			$query = $this->db->get();
			
			$result['app_filter'] 	= $app_filter; 
			$result['projects'] 	= $query->result_array();
			
		//}
		return $result;
	}
}
