<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

	set_cache_header();
	
	$date_filter_this	= array(
		'TO' => 'TODAY',
		'TW' => 'THIS_WEEK',
		'TS' => 'THIS_SEMI_MONTHLY',
		'TM' => 'THIS_MONTH',
		'TQ' => 'THIS_QUARTER',
		'TY' => 'THIS_YEAR',
		'TA' => 'THIS_ACCOUNT_YEAR'
	);
	$date_filter_last	= array(
		'YE' => 'YESTERDAY',
		'LW' => 'LAST_WEEK',
		'LS' => 'LAST_SEMI_MONTHLY',
		'LM' => 'LAST_MONTH',
		'LQ' => 'LAST_QUARTER',
		'LY' => 'LAST_YEAR',
		'LA' => 'LAST_ACCOUNT_YEAR'
	);
	$expenses_filter_this	= array(
		'TQ' => 'THIS_QUARTER',
		'TY' => 'THIS_YEAR',
		'TA' => 'THIS_ACCOUNT_YEAR'
	);
	$expenses_filter_last	= array(
		'LQ' => 'LAST_QUARTER',
		'LY' => 'LAST_YEAR',
		'LA' => 'LAST_ACCOUNT_YEAR'
	);
?>
<div class="page-header-bar">
	<span class="title"><?php echo lang('DASHBOARD_TITLE'); ?></span>
</div>
<div class="dib box fw">
	<div class="col-md-6" data-bind="with:ts_hrs">
		<div class="row">
			<h4 class="col-sm-3 nm"><?php echo lang('OUTPUT_HOURS'); ?></h4>
			<?php if(!is_member($role)) { ?>
			<div class="btn-group btn-toggle col-sm-3"> 
				<button class="btn btn-xs " data-bind="click:swap_view, css:{'btn-primary active': !is_team_view(), 'btn-default' :is_team_view()}"><?php echo lang('MY'); ?></button>
				<button class="btn btn-xs " data-bind="click:swap_view, css:{'btn-primary active': is_team_view(), 'btn-default' :!is_team_view()}"><?php echo lang('TEAM'); ?></button>
			</div> 
			<?php } ?>
			<div class="col-sm-6 ar">
				<div class="dib pr vam">
					<span class="cp badge small" data-bind="click:function(){date_filter.is_dft(!date_filter.is_dft());}">
						<!-- ko text:_info.date_filter_disp --><!-- /ko --> <i class="icon-chevron-down icon-white" style="margin-left:10px;">&nbsp;</i>
					</span>
					<div class="dropdown-menu al dtFilter" data-bind="css:{'active':date_filter.is_dft}" style="left:-55px; width:325px;">
						<ul class="dropdown-menu pull-left list-unstyled">
						<?php
							foreach ($date_filter_this as $key=>$val)
							{
								echo '<li class="" data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
							}
						?>
						</ul>
						<ul class="dropdown-menu pull-left list-unstyled">
						<?php
							foreach ($date_filter_last as $key=>$val)
							{
								echo '<li class="" data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
							}
						?>
						</ul>
					</div>
				</div>
				<div class="dib pr vam">
					<div class="pull-left pr">
						<h5 class="pull-left no-margin" style="padding:4px 6px;" data-bind="text:date_disp"></h5>
						<input type="text" id="date-picker" class="fw dib dtpicker np nm nb fh cp" data-bind="value:date, datepicker:true" />
					</div>
					<div class="pull-left">
						<a href="javascript:;" data-bind="click:dateUpDown.bind($data, '-')" class="icon-chevron-left"></a>&nbsp;&nbsp;
						<a href="javascript:;" data-bind="click:dateUpDown.bind($data, '+')" class="icon-chevron-right"></a>
					</div>
				</div>
			</div>
		</div>
		<span class="clearfix"></span>
		<div class="row ot_hrs">
			<h4 class="col-xs-4 ac"><small class="bill" ><?php echo lang('BILLABLE')?></small><div  data-bind="text:Number(billable()).toFixed()+ ' Hrs'" ></div></h4>
			<h4 class="col-xs-4 ac"><small class="nonbill" ><?php echo lang('NON_BILLABLE')?></small>&nbsp;<div  data-bind="text:Number(non_billable()).toFixed()+ ' Hrs'" ></div></h4>
			<h4 class="col-xs-4 ac"><small><?php echo lang('TOTAL')?></small>&nbsp;<div  data-bind="text:Number(total()).toFixed()+ ' Hrs'" ></div></h4>
		</div>
		<div class="col-xs-12  col-md-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart(), stackedBar:{data:stackedBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, stack:stack, tooltip_lsuffix:' hrs', tooltip_format:Otime.formatHrs}">
		</div>
	</div>
	<div class="col-md-6" data-bind="with:pr_hrs">
		<div class="row">
			<h4 class="col-sm-3 nm"><?php echo lang('PROJECT_HOURS'); ?></h4>
			<div class="col-sm-9">
				<div class="row">
					<div class="col-sm-5 ar">
						<span class="cp badge small" data-bind="click:function(){date_filter.is_dft(!date_filter.is_dft());}">
							<!-- ko text:_info.date_filter_disp --><!-- /ko --> <i class="icon-chevron-down icon-white" style="margin-left:10px;">&nbsp;</i>
						</span>
						<div class="dropdown-menu al dtFilter" data-bind="css:{'active':date_filter.is_dft}" style="left:-55px; width:325px;">
							<ul class="dropdown-menu pull-left list-unstyled">
							<?php
								foreach ($date_filter_this as $key=>$val)
								{
									echo '<li data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
								}
							?>
							</ul>
							<ul class="dropdown-menu pull-left list-unstyled">
							<?php
								foreach ($date_filter_last as $key=>$val)
								{
									echo '<li data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
								}
							?>
							</ul>
						</div>
					</div>
					<div class="col-sm-7 ar">
						<div class="dib pr">
							<h5 class="nm" style="padding:4px 6px;" data-bind="text:date_disp"></h5>
							<input type="text" id="date-picker" class="fw dib dtpicker np nm nb fh cp" data-bind="value:date, datepicker:true" />
						</div>
						<div class="dib">
							<a href="javascript:;" data-bind="click:dateUpDown.bind($data, '-')" class="icon-chevron-left"></a>&nbsp;&nbsp;
							<a href="javascript:;" data-bind="click:dateUpDown.bind($data, '+')" class="icon-chevron-right"></a>
						</div>
					</div>
				</div>
			</div>
		</div>
		<div class="clearfix"></div>
		<div class="row ot_hrs">
			<?php $class = is_admin($role) ? "col-xs-3  col-md-3 text-center" : "col-xs-6  col-md-6 text-center"; ?>
			<h4 class="<?php echo $class;?>"><small class="bill" ><?php echo lang('BILLABLE')?></small><div  data-bind="text:Number(billable_hours()).toFixed()+ ' Hrs'" ></div></h4>
			<h4 class="<?php echo $class;?>"><small class="nonbill" ><?php echo lang('NON_BILLABLE')?></small>&nbsp;<div  data-bind="text:Number(nonbillable_hours()).toFixed()+ ' Hrs'" ></div></h4>
			<?php if (is_admin($role)){ ?>
				<h4 class="<?php echo $class;?>"><small><?php echo lang('INVOICED')?></small><div  data-bind="text:Number(invoiced_hours()).toFixed()+ ' Hrs'" ></div></h4>
				<h4 class="<?php echo $class;?>"><small><?php echo lang('UNINVOICED')?></small>&nbsp;<div  data-bind="text:Number(uninvoiced_hours()).toFixed()+ ' Hrs'" ></div></h4>
			<?php } ?>
		</div>
		<div style="height:202px;overflow:auto">
			<table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-hover">
				<tbody data-bind="foreach:pr_amount">
					<tr data-bind="visible:total_hours">
						<td class="nb-td col-md-4 col-sm-8 col-xs-9">
							<span data-bind="text:project_name"></span>
							<span class="visible-sm visible-xs clear"></span>
							<div class="row nm visible-sm visible-xs">
								<div class="progress progress-bar-nonbill pull-left" data-bind="style:{width:(100 / $parent.max_total) * total_hours+'%'}" >
									<!--  ko if:billable_hours > 0 -->
										<div style="padding: 2px;" data-bind="style:{width:(billable_hours_per)+'%'}, text:Number(billable_hours).toFixed()" class="progress-bar progress-bar-bill"></div>
									<!-- /ko -->
								</div>
							</div>
						</td>
						<td class="nb-td hidden-sm hidden-xs">
							<div class="col-md-12 pull-left np">
								<div class="progress progress-bar-nonbill pull-left" data-bind="style:{width:(100 / $parent.max_total) * total_hours+'%'}" >
									<!--  ko if:billable_hours > 0 -->
										<div style="padding: 2px;" data-bind="style:{width:(billable_hours_per)+'%'}, text:Number(billable_hours).toFixed()" class="progress-bar progress-bar-bill"></div>
									<!-- /ko -->
								</div>
							</div>
						</td>
						<td class="nb-td col-md-2 col-sm-4 col-xs-3">
							<small style="margin-left:10px;font-size: 11px;">
								<span data-bind="hours:{val:total_hours}"></span>
								<small>&nbsp;hrs</small>
							</small>
						</td>
					</tr>
				</tbody>
			</table>
		</div>
	</div>
</div>
<div class="dib box fw">
	<?php if (is_admin($role)){ ?>
	<div class="col-md-6">
		<div class="col-md-6 npl" data-bind="with:out_invoices(), visible:out_invoices().listing().length > 0">
			<h4><?php echo lang('OUTSTANDING_AMOUNT'); ?></h4>
			<h4 class="ar"><small >Total Due </small><span data-bind="html: Otime.Currency + total_due.toFixed()"></span></h4>
			<div class="row nm" >
				<table cellpadding="0" cellspacing="0" border="0" class="table table-striped table-hover nm">
					<tbody data-bind="foreach:listing">
						<tr>
							<!--  ko ifnot:$index-->
							<td data-bind="text:name" colspan="2"></td>
							<!-- /ko -->
							<!--  ko if:$index-->
							<td><span data-bind="visible:$index()==1"><?php echo lang('OVER_DUE'); ?></span></td><td data-bind="text:name"></td>
							<!-- /ko -->	
							<td data-bind="html: Otime.Currency + amount " class="ar"></td>
						</tr>
					</tbody>
				</table>
			</div>
		</div>
		<div class="col-md-6"  data-bind="with:amt_hrs">
			<h4><?php echo lang('INVOICES'); ?></h4>
			<span class="clearfix"></span>
			<div class="col-xs-12  col-md-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart(), stackedBar:{data:stackedBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, tooltip_lprefix:Otime.Currency, stack:stack()}"></div>
		</div>
	</div>
	<?php } ?>
	<div class="col-md-6">
		<div class="col-md-6"  data-bind="with:ts_sts" >
			<div class="row nm">
				<h4><?php echo lang('TASK_STATUS'); ?>
					<small class="col-md-7 pull-right np fs-12">
						<select data-bind="options:$root.projects, optionsText:'project_name', optionsValue:'project_id', value:project_id,fancy:true" class="form-control input-sm nm">
						</select>
					</small>
				</h4>
			</div>
			<!-- ko if:pieChart().length>0 -->
			<div>
				<div class="col-md-12" style="height:200px;position:relative; display:block;" data-bind="pie:{donut:false, legend:true, colors:colors, data:pieChart()}"></div>
			</div>
			<!-- /ko -->
		</div>
		<div class="col-md-6"  data-bind="with:ty_sts" >
			<div class="row nm">
				<h4><?php echo lang('TASK_TYPES'); ?>
					<small class="col-md-7 pull-right np fs-12">
						<select data-bind="options:$root.projects, optionsText:'project_name', optionsValue:'project_id', value:project_id,fancy:true" class="form-control input-sm nm">
						</select>
					</small>
				</h4>
			</div>
			<!-- ko if:pieChart().length>0 -->
			<div>
				<div class="col-md-12" style="height:200px;position:relative; display:block;" data-bind="pie:{donut:false, legend:true, data:pieChart(), tooltip_lsuffix:' hrs'}"></div>
			</div>
			<!-- /ko -->
		</div>
	</div>
</div>
<div class="dib box fw">
	<?php if (is_admin($role)){ ?>
	<div class="col-md-6" data-bind="with:inc_exp">
		<div class="row">
			<h4 class="col-md-4 npr nm"><?php echo lang('INCOME_VS_EXPENSES'); ?></h4>
			<div class="col-md-8 ar">
				<div class="dib pr vam">
					<span class="cp badge small" data-bind="click:function(){date_filter.is_dft(!date_filter.is_dft());}">
						<!-- ko text:_info.date_filter_disp --><!-- /ko --> <i class="icon-chevron-down icon-white" style="margin-left:10px;">&nbsp;</i>
					</span>
					<div class="dropdown-menu al dtFilter" data-bind="css:{'active':date_filter.is_dft}" style="left:-55px; width:325px;">
						<ul class="dropdown-menu pull-left list-unstyled">
						<?php
							foreach ($expenses_filter_this as $key=>$val)
							{
								echo '<li class="" data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
							}
						?>
						</ul>
						<ul class="dropdown-menu pull-left list-unstyled">
						<?php
							foreach ($expenses_filter_last as $key=>$val)
							{
								echo '<li class="" data-bind="click:function(){date_filter.applyDFT(\'' . $key . '\')}"><a href="javascript:;">' . lang($val) . '</a></li>';
							}
						?>
						</ul>
					</div>
				</div>
				<div class="dib pr vam">
					<div class="pull-left pr">
						<h5 class="pull-left no-margin" style="padding:4px 6px;" data-bind="text:date_disp"></h5>
						<input type="text" id="date-picker" class="fw dib dtpicker np nm nb fh cp" data-bind="value:date, datepicker:true" />
					</div>
					<div class="pull-left">
						<button data-bind="click:dateUpDown.bind($data, '-')" class="btn no-bg nb np icon-chevron-left dib" type="button"></button>
						<button data-bind="click:dateUpDown.bind($data, '+')" class="btn no-bg nb np icon-chevron-right dib" type="button"></button>
					</div>
				</div>
			</div>
		</div>
		<span class="clearfix"></span>
		<div class="row ot_hrs">
			<h4 class="col-xs-4 ac"><small class="income"><?php echo lang('INCOME')?></small><div  data-bind="html:Otime.Currency + Number(income()).toFixed()" ></div></h4>
			<h4 class="col-xs-4 ac"><small class="expense"><?php echo lang('EXPENSES')?></small>&nbsp;<div  data-bind="html:Otime.Currency +(expenses()).toFixed()" ></div></h4>
			<h4 class="col-xs-4 ac"><small><?php echo lang('TOTAL')?></small>&nbsp;<div  data-bind="css:{'red':total()<0,'green':total()>0}, html:Otime.Currency +Number(total()).toFixed()" ></div></h4>
		</div>
		<span class="clearfix"></span>
		<div class="col-xs-12" style="height:200px;position:relative; display:block;" data-bind="visible:show_chart(), multiBar:{data:multiBar(), ticks:ticks(), colors:colors(), legend:false, tooltip:true, tooltip_lprefix:Otime.Currency}"></div>
	</div>
	<?php } ?>
	<div class="col-md-6" data-bind="with:milestones, visible:(milestones().project_id()>0 || milestones().overdue()>0 || milestones().upcoming()>0 || milestones().duetoday()>0)">
		<div class="row nm">
			<h4><?php echo lang('MILESTONES'); ?>
				<small class="col-md-7 pull-right np fs-12">
					<select data-bind="options:$root.projects, optionsText:'project_name', optionsValue:'project_id', optionsCaption:'All Projects', value:project_id,fancy:true" class="form-control input-sm nm">
					</select>
				</small>
			</h4>
		</div>
		<div class="row nm">
			<h3 class="col-xs-4 ac"><small class="nonbill"><?php echo lang('OVERDUE')?></small><div data-bind="text:Number(overdue())"></div></h3>
			<h3 class="col-xs-4 ac"><small><?php echo lang('UPCOMING');?></small><div data-bind="text:Number(upcoming())"></div></h3>
			<h3 class="col-xs-4 ac" data-bind="visible:duetoday()>0"><small class="bill"><?php echo lang('DUE_TODAY')?></small>&nbsp;<div  data-bind="text:Number(duetoday())" ></div></h3>

  		</div>
	</div>
</div>
<?php
$jslang	= array();

$tmp	= array(
	'REPORT_T_TITLE',
	'REPORT_TS_TITLE',
	'REPORT_TD_TITLE',
	'REPORT_TK_TITLE',
	'REPORT_I_TITLE',
	'REPORT_IS_TITLE',
	'REPORT_ID_TITLE',
	'REPORT_IA_TITLE',
	'REPORT_IO_TITLE',
	'REPORT_IU_TITLE',
	'REPORT_UO_TITLE',
	'REPORT_UE_TITLE',
	'REPORT_BU_TITLE',
	'REPORT_BD_TITLE',
	'REPORT_E_TITLE',
	'REPORT_ES_TITLE',
	'REPORT_ED_TITLE',
	'REPORT_AGING_DETAIL_TITLE',
	'TODAY',
	'THIS_WEEK',
	'THIS_SEMI_MONTHLY',
	'THIS_MONTH',
	'THIS_QUARTER',
	'THIS_YEAR',
	'THIS_ACCOUNT_YEAR',
	'YESTERDAY',
	'LAST_WEEK',
	'LAST_SEMI_MONTHLY',
	'LAST_MONTH',
	'LAST_QUARTER',
	'LAST_YEAR',
	'LAST_ACCOUNT_YEAR'
);
foreach ($tmp as $val)
{
	$jslang[$val]	= lang($val);
}
?>
<script type="text/javascript">
	$(document).ready(function(){
		Otime.Dashboard.language	= <?php echo json_encode($jslang); ?>;
		Otime.Dashboard.filter_labels	= <?php echo json_encode(array_merge($date_filter_this, $date_filter_last)); ?>;
		Otime.Dashboard.dft	= 'TW'; // Date filter type
		Otime.Dashboard.exp_dft	= 'TY';
		Otime.Dashboard.inv_dft	= 'TQ';
		Otime.Dashboard.is_team_view = <?php echo is_member($role) ? 'false' : 'true';?>;
	});
</script>
