<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

?>
<div class="day-view" data-bind="with:day_view">
	<div class="widget" data-bind="foreach:items">
		<div class="nmr">
			<div class="dib fw pr">
				<div class="col-md-1 col-sm-1 col-xs-2 np">
					<div class="dib ac">
						<span class="dib fw ac" data-bind="date:{date:date, format:'MMM'}"></span>
						<div class="dib label label-default" data-bind="css:{'label-success':is_today, 'leave':is_leave}" style="width:40px;">
							<span class="dib ac h4 nm" data-bind="date:{date:date, format:'DD'}"></span>
							<br/>
							<span class="dib ac h5 nm" data-bind="date:{date:date, format:'DDD'}"></span>
						</div>
					</div>
				</div>
				<div class="col-md-4 col-sm-5 col-xs-10 np btn-group btn-sm" style="margin-top:20px;">
					<span class="h3 btn btn-default nm" data-bind="hidden:is_running,hours:{val:hours, showNull:true}"></span>
					<span class="h3 btn btn-default nm" data-bind="visible:is_running,hours:{val:running_hours, showNull:true}"></span>
					<button class="btn btn-success" data-bind="click:$parent.addNew, disable:Otime.app.is_edit_mode">
						<span class="icon-white icon-plus"></span>
					</button>
					<?php if (is_member($role) && $isAR): ?>
					<button class="btn btn-primary approval" data-bind="click:submit, disable:Otime.app.is_edit_mode, visible:isApprove" type="button"><?php echo lang('SUBMIT_FOR_APPROVAL'); ?></button>
					<?php endif; ?>
				</div>
			</div>
			<!-- ko foreach:listing -->
			<div class="time_rows dib fw pr" data-bind="css:{'in-act gray':!_info.is_active()}"><?php // data-bind="ifnot:_info.is_running" ?>
				<span class="col-md-1">&nbsp;</span>
				<div data-bind="template:{name:'timesheet-list-tmpl'}, visible:(!_info.is_new())" class="fixwidth col-lg-9 col-md-11 col-sm-12 npl nm time_entry"></div>
				<!-- ko if:(_info.is_edit_mode() || _info.is_new()) -->
				<div class="tsheet popover" data-bind="template:{name:'timesheet-popup-tmpl'}, visible:is_fresh"></div>
				<div data-bind="template:{name:'timesheet-edit-tmpl'}, visible:(is_fresh()===false && $parent.is_today())" class="fixwidth row col-lg-9 col-md-11 col-sm-12 nm well pr" id="newItem"></div>
				<!-- /ko -->
				<span class="col-md-1 visible-lg">&nbsp;</span>
			</div>
			<!-- /ko -->
		</div>
	</div>
	<button class="btn btn-success btn-sm" data-bind="click:load_more"><?php echo lang('LOAD_MORE'); ?></button>
</div>
<script id="timesheet-list-tmpl" type="text/html">
	<!-- ko if:((status()!='' && _info.user_role()=='M') || invoice_id>0) -->
	<span class="pull-right" ><i class="icon icon-lock gray"></i></span>
	<!-- /ko -->
	<?php if (is_member($role)): ?>
	<img class="icon icon-lock pull-right gray img12x12" data-bind="visible:status()=='A'" src="<?php echo base_url(); ?>assets/img/lock_tick.png"></i>
	<?php endif; ?>
	<div class="col-md-5 col-sm-6 col-xs-6" data-bind="attr:{style: 'border-left:3px solid ' + _info.bg_color()}">
		<span title="High Priority" data-bind="visible:_info.task_priority()==1" class="text-danger h5 b" style="left: 2px;margin-top: 1px;position: absolute;margin-left:-20px;">&#8593;</span>		
		<span title="Low Priority" data-bind="visible:_info.task_priority()==3" class="text-success h5 b" style="left: 2px;margin-top: 1px;position: absolute;margin-left:-20px;">&#8595;</span>		
		<i class="task-flag" data-bind="text:'Task #'+_info.task_number(), click:$parent.showTask, visible:(project_task_id()-0)>0"></i>
		<span class="h4 task_name" data-bind="text:activity_name, visible:activity_name()!=''"></span>
		<span class="h4 task_name" data-bind="text:_info.project_name, visible:activity_name()==''"></span>
		<span class="gray" data-bind="visible:estimated_hours()>0" style="white-space:nowrap;font-size:11px;">
			<!-- ko text:estimated_hours --><!-- /ko -->&nbsp;<!-- ko if:estimated_hours()>1 -->Hrs<!-- /ko --><!-- ko if:estimated_hours()==1 -->Hr<!-- /ko -->
		</span>
		<br/>
		<div class="dib fw">
		<!-- ko if:(activity_name()!='') -->
			<span class="h5 np" data-bind="text:_info.project_name, style:{color:_info.bg_color}"></span>&nbsp;&nbsp;
			<span class="clearfix visible-xs"></span>
		<!-- /ko -->
			<span class="gray np" data-bind="text:_info.task_type_name"></span>&nbsp;
			<span class="com-md-1 nm cp ar icon-edit gray" ttip="Show hide Comments." data-bind="visible:notes, click:showCmt('cmt')" style="padding-top:13px;"></span>
		</div>
		<pre class="gray time_desc np" data-bind="visible:_info.is_cmt, text:notes" style="background:none;border:none;"></pre>
	</div>
	<div class="col-md-3 col-sm-6 col-xs-6">
		<h3 class="pull-left nm" data-bind="hidden:_info.is_running, hours:{val:hours}, css:{gray:status()!=''&&_info.user_role() =='M'}"></h3>
		<h3 class="nm pull-left" data-bind="html:_info.hours_disp, visible:_info.is_running"></h3>
		<a href="javascript:;" class="start pull-right blue" data-bind="click:$parent.continueTask, visible:_info.showBtn()&&_info.enStart()"><?php echo lang('CONTINUE'); ?></a>
		<button type="button" class="btn btn-sm btn-danger stop pull-right" data-bind="click:$parent.stop, enable:_info.enStart, visible:_info.is_running">
			<span class="icon-pause icon-white"></span>&nbsp;<?php echo lang('PAUSE'); ?>
		</button>
	</div>
	<div class="col-md-3 col-sm-12 col-xs-12 hidden-xs">
		<table class="table pull-left nm time-list-table">
			<colgroup>
				<col width="33.33%" />
				<col width="10%" />
				<col width="33.33%" />
			</colgroup>
			<tbody data-bind="foreach:details">
				<tr class="gray" data-bind="css:{'error':isValid()==false}, visible:(from_time() || to_time())">
					<td class="np nbt ar" data-bind="time:from_time"></td>
					<td class="ac np nbt">&nbsp;<?php echo lang('TO'); ?>&nbsp;</td>
					<td class="np nbt">
					<!-- ko ifnot:is_progress -->
						<!-- ko time:to_time --><!-- /ko -->
					<!-- /ko -->
					<!-- ko if:is_progress -->
						&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<i class="icon icon-time blinks"></i>
					<!-- /ko -->
					</td>
				</tr>
			</tbody>
		</table>
	</div>
	<!-- ko if:((_info.is_editable() && !Otime.app.is_edit_mode() && !_info.is_running()))-->
	<div class="edit cp col-md-1 npl pull-right">
		<span class="edit_time" data-bind="click:$parent.edit"><i class="icon icon-pencil"></i></span>
		<span class="" data-bind="click:$parent.remove, visible:time_sheet_id()>0">|&nbsp;<i class="icon icon-trash cp"></i></span>									
	</div>
	<!-- /ko -->
</script>
<script id="timesheet-edit-tmpl" type="text/html">
	<div class="row">
		<div class="col-sm-8 col-xs-12">
			<div class="row mb10">
				<div class="col-md-6 col-xs-12 clrbg">
					<select tabindex="1" data-bind="options:$root.projects, optionsText:'label', optionsValue:'id', optionsCaption:'<?php echo lang('SELECT_THE_PROJECT'); ?>', value:project_id, chosen:true">
					</select>
				</div>
				<div class="col-md-5 col-sm-11 col-xs-10 clrbg">
					<select tabindex="2" data-bind="options:_info.task_types, optionsText:'name', optionsValue:'task_type_id', optionsCaption:'Select Task type...', value:task_type_id, chosen:true">
					</select>
				</div>
				<div class="col-md-1 col-sm-1 col-xs-1 ts-billable pr">
					<?php if ($isModifyBillable){ ?>
					<a title="Billable" class="selected" href="javascript:;" data-bind="click:function(){is_billable(!is_billable());}, attr:{disabled:!is_billable()}" style="position:absolute; top:10px;">
						<i class="icon-dollar icon-metro img-circle"></i>
					</a>	
					<?php } else { ?>
					<a title="Billable" class="selected" href="javascript:;" data-bind="attr:{disabled:!is_billable()}" style="cursor:default;position:absolute;top:10px;" readonly="">
						<i class="icon-dollar icon-metro img-circle"></i>
					</a>
					<?php } ?>
				</div>
			</div>
			<div class="row" style="margin-bottom:4px;">
				<div class="col-xs-12">
					<input type="text" tabindex="3" class="form-control input-sm" placeholder="<?php echo lang('ACTIVITY'); ?>" data-bind="value:activity_name, autoComplete:{source:getTasks, select:setTasks}" autofocus />
				</div><?php /*
				<div class="sep visible-xs visible-sm">&nbsp;</div>
				<div class="col-md-1 col-sm-1 col-xs-2">
					<span class="col-md-2 col-xs-2 hidden-sm hidden-xs np cp icon-edit" style="line-height:30px;" ttip="Show hide Comments." data-bind="click:showCmt('cmt')" style="padding-right:15px;"></span>
				</div>
			*/?></div>
		</div>
		<div class="col-sm-4 col-xs-12">
			<span class="dib vat mb10">
				<input type="text" tabindex="5" style="width:85px;" placeholder="<?php echo lang('HOURS'); ?>" data-bind="numberOnly:{keyCodes:[58]}, value:hoursDisp, event:{focus:updateHrs, change:onChange}, hidden:(!!(Otime.tsReq-0))" maxlength="5" class="form-control input-lg" />
				<h2 class="nm" style="width:85px;" data-bind="hours:{val:hours}, visible:(!!(Otime.tsReq-0))"></h2>
			</span>&nbsp;&nbsp;
			<div class="dib ac" margin-left:10px;>
				<button type="button" tabindex="8" class="btn btn-success btn-lg start" data-bind="click:$parent.continueTask, enable:_info.enStart, visible:_info.showBtn">
					<span class="icon-play icon-white"></span>&nbsp;<!-- ko if:_info.is_new --><?php echo lang('START'); ?><!-- /ko --><!-- ko ifnot:_info.is_new --><?php echo lang('CONTINUE'); ?><!-- /ko -->
				</button>
				<button type="button" tabindex="8" class="btn btn-sm btn-danger stop" data-bind="click:$parent.stop, disable:Otime.app.is_edit_mode, visible:_info.is_running">
					<span class="icon-pause icon-white"></span>&nbsp;<?php echo lang('PAUSE'); ?>
				</button>
				<div class="sep">&nbsp;</div>
				<a class="blue cp" tabindex="9" href="javascript:;" style="padding:7px 17px;" data-bind="click:$parent.save"><?php echo lang('SAVE'); ?></a>
			</div>
		</div>
	</div>
	<!-- ko if:_info.is_extra -->
	<div class="row">
		<div class="col-sm-8 col-xs-12">
			<textarea class="fwt form-control input-sm" tabindex="4" placeholder="<?php echo lang('DESCRIPTION'); ?>" data-bind="value:notes"></textarea>
		</div>
		<div class="sep visible-xs pull-left">&nbsp;</div>
		<div class="col-sm-4 col-xs-12">
			<div class="row nm">
				<input type="text" tabindex="6" placeholder="<?php echo lang('EST_HRS'); ?>" maxlength="5" class="form-control input-sm" data-bind="numberOnly:{keyCodes:[58]}, value:estimatedHoursDisp, event:{change:onChangeEst}" style="width:85px;" />
			</div>
			<table class="table table-condensed time-edit-table nm">
				<colgroup><col class="col-md-4"><col class="col-md-1"><col class="col-md-4"><col class="col-md-2"><col class="col-md-1"></colgroup>
				<tbody data-bind="foreach:details">
					<tr class="detail" data-bind="css:{'error':isValid()==false}">
						<td class="ac nb"><input tabindex="7" type="text" class="input-xs col-xs-12 np ac fromDt" data-bind="value:from_time, timeEntry:{date:$parent.entry_date}, event:{blur:function(data, event){$parent.newHrs($index, data, event); itemBlur(data, event, 'from'); }}" title="<?php echo lang('START_TIME'); ?>" /></td>
						<td class="ac nb"><?php echo lang('TO'); ?></td>
						<td class="ac nb"><input tabindex="7" type="text" class="input-xs text-center col-xs-12 np toDt" data-bind="value:to_time, timeEntry:{date:$parent.entry_date, autoAMPM:1, minTime:from_time}, event:{blur:itemBlur}" title="<?php echo lang('END_TIME'); ?>" /></td>
						<td class="ar nb vam"><span class="label label-default dib h5 nm" data-bind="hours:{val:hours, showNull:true}"></span></td>
						<td class="ar nb vam"><span class="icon icon-trash cp" data-bind="click:$parent.deleteHrs, visible:from_time" title="<?php echo lang('DELETE_HOURS'); ?>"></span></td>
					</tr>
				</tbody>
				<tfoot data-bind="if:direct_entry">
					<td colspan="3" class="ar vam gray"><?php echo lang('DIRECT_ENTRY'); ?></td>
					<td class="ar nb vam"><span class="label label-default dib h5" data-bind="hours:{val:direct_entry, showNull:true}"></span></td>
					<td></td>
				<tfoot>
			</table>
		</div>
	</div>
	<!-- /ko -->
	<span class="more gray icon-chevron-down" data-bind="css:{'icon-chevron-down':!_info.is_extra(),'icon-chevron-up':_info.is_extra}, click:swap_extra"></span>
</script>
