﻿(function(Otime) {

	Otime.Client	= new function Client(){
//		"use strict";

		var _this	= this;

		_this.name	= "clients";

		_this.model	= "ClientListModel";

		_this.language	= null;

		_this.CID	= 0;

		_this.addNew	= function(){
			_this.listModel.addItem();
		};

		_this.ClientListModel	= function(data){
			var self	= this;

			data	= data || {};

			self.is_list_view	= Otime.o(false);
			self.swapView	= function(){
				self.is_list_view(!self.is_list_view());
			};

			self.items	= Otime.a([]);

			self.selectedItem	= Otime.o(null);
			self.popupItem	= Otime.o(null);

			self.addItem	= function(){
				console.log('edit add');
				self.editItem(new _this.ClientContentModel(null, self));
			};

			self.is_new_mode	= Otime.o(false);
			self.is_edit_mode	= Otime.o(false);
			self.show_loading	= Otime.o(false);
			self.loading	= Otime.o(false);
			self.show_more	= Otime.o(true);
			self.finish		= Otime.o(true);
			self.page	= 1;
			self.archive_count	= Otime.o(0);
			self.active_count	= Otime.o(0);
			self.active 		= Otime.o(1);

			self.load_more	= function(){
				if (self.finish())
				{
					return false;
				}
				var data = { active: self.active() };
				self.page++;
				Otime.app.loadData(new Otime.ContextModel("listing/" + self.page, data, function(cont){
					var resp	= cont.response;
					self.finish(resp.finish || false);
					if (resp.finish == true)
					{
						self.show_more(false);
					}
					if (resp.items && resp.items.otvalues && Object.keys(resp.items.otvalues).length > 0)
					{
						resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(itm){
							self.items.push(new _this.ClientContentModel(itm, self));
						});
					}

					if(!self.is_list_view())
					{
						_this.list_container.masonry("reload");
					}
					else
					{
						_this.list_container.css("height", "auto");
					}
				}));
			};

			self.get_info	= function(item, elem){
				if ($(elem.delegateTarget).parent().hasClass("open"))
				{
					return true;
				}
				item.loadInfo();
			};

			self.get_contacts	= function(item, elem){
				item.is_show_contact(!item.is_show_contact());

				if (item.contacts().length <= 0)
				{
					var context = new Otime.ContextModel("contacts/" + item.client_id(), null, item.set_contacts);
					context.prepare = true;
					Otime.app.loadData(context);
					return true;
				}
			}

			self.edit	= function(target){
				target.addcontact();
				ko.editable(target);
				target.beginEdit();

				self.is_edit_mode(true);
				_this.list_container.masonry('reload');

				Otime.resizePageSlide();
			};

			self.editItem	= function(item, elem){
				if (item.is_active() == 0)
				{
					return false;
				}
				self.selectedItem(item);
				self.popupItem(item);

				if (!Otime.app.hasBinding(_this.edit_container))
				{
					Otime.app.load_template("edit", function(response){
						_this.edit_container.html($.trim(response));

						if (self.popupItem() == null)
						{
							self.popupItem(new _this.ClientContentModel(null, self));
						}
						ko.applyBindings({popupitem:self.popupItem}, _this.edit_container.get(0));
						self.editItem(item, elem);
					});
					return false;
				}

				if (item.client_id() <= 0)
				{
					var newItem	= new _this.ClientContentModel(null, self);
					self.selectedItem(newItem);
					self.popupItem(newItem);
					self.edit(newItem);
					Otime.resizePageSlide();
					_this.list_container.masonry('reload');
				}
				else
				{
					Otime.Menu.ReplaceURL(_this.name + "/" + item.client_id());
					Otime.app.loadData(new Otime.ContextModel({
						url: "edit/" + item.client_id(),
						global: false,
						callback: function(cont){
							self.load(cont);
						},
						params: "EDIT"
					}));
				}
			};

			self.load	= function(context){
				var src	= self.selectedItem();
				var data	= context.response || {};
				var newItem	= new _this.ClientContentModel(null, self);

				if (data)
				{
					newItem.client_id(data.client_id || src.client_id());
					newItem.client_name(data.client_name || src.client_name());
					newItem.title(data.title || src.title());
					newItem.bg_color(data.bg_color || src.bg_color());
					data.client_code = (data.client_code) ? $.trim(data.client_code.replace('-', '')) : '';
					newItem.client_code(data.client_code || src.client_code());

					newItem.address(data.address || src.address());
				}

				if (data.contacts && data.contacts.otvalues && Object.keys(data.contacts.otvalues).length > 0)
				{
					var ct	= [];
					data.contacts = data.contacts.otvalues.setKeys(data.contacts.otkeys, function(val){
						ct.push(new _this.ContactsModel(val));
					});
					newItem.contacts(ct);
				}

				if (data.info)
				{
					newItem._info.active_projects(data.info.active_projects-0 || 0);
					newItem._info.projects_count(data.info.projects_count-0 || 0);
					newItem._info.unpaid_invoice(data.info.unpaid_invoice-0 || 0);
					newItem._info.all_invoice(data.info.all_invoice-0 || 0);
				}

				if (self.is_new_mode() == false && context.params == "EDIT")
				{
					self.edit(newItem);
				}
				self.popupItem(newItem);
				return newItem;
			};

			self.saveItem	= _this.Save;

			self.cancel	= function(){
				var item	= self.selectedItem();

				item.rollback && item.rollback();
				item.client_name((item.client_code()?item.client_code()+" - ":"")+item.client_name());
				self.is_edit_mode(false);
				self.selectedItem(new _this.ClientContentModel());
				_this.list_container.masonry('reload');
				Otime.Menu.ReplaceURL(_this.name);
			};

			self.deleteItem	= function(item, elem){
				if (item.actual_value() > 0)
				{
					alert("Project associated with this client have hours, So you can't delete this client.");
					return false;
				}

				if (item.client_id() > 0 && confirm(_this.language["DELETE_CLIENT_CONFIRM_MSG"]) == true)
				{
					Otime.app.postData(new Otime.ContextModel({
						url: "delete/" + item.client_id(),
						global: false,
						callback: function(){
							self.items.remove(item);
							_this.list_container.masonry('reload');
						}
					}));
					return true;
				}
			};

			self.archiveItem = function(val) {
				return function(item, elem){
					if(item._info.active_projects() > 0)
					{
						alert(_this.language["CANNOT_ARCHIVE_CLIENT_MSG"]);
						return;
					}

					var msg	= _this.language["ARCHIVE_CLIENT_CONFIRM_MSG"];
					if(val == 1)
					{
						var msg	= _this.language["UNARCHIVE_CLIENT_CONFIRM_MSG"];
					}

					if (item.client_id() > 0 && confirm(msg))
					{
						Otime.app.postData(new Otime.ContextModel({
							url: "archive/" + item.client_id(),
							global: false
						}, {
							is_active: val
						}, function(){
							item.is_active(val);
							self.items.remove(item);
							if (!self.is_list_view())
							{
								_this.list_container.masonry('reload');
							}
							if(val == 1)
							{
								self.archive_count(Number(self.archive_count())-1);
								self.active_count(Number(self.active_count())+1);
								if(self.archive_count() <= 0)
								{
									self.active(0);
								}
							}
							else
							{
								self.active_count(Number(self.active_count())-1);
								self.archive_count(Number(self.archive_count())+1);
								if(self.active_count() <= 0)
								{
									self.active(1);
								}
							}
						}));
					}
				};
			};

			self.refresh	= function(active){
				self.page = 1;
				var data	= {
					active: active
				};
				Otime.app.postData(new Otime.ContextModel({
					url: "listing",
					data: data,
					callback: function(cont){
						var resp	= cont.response,
							flag0	= false;
						self.finish(!!resp.finish);
						if (resp.items && resp.items.otvalues && resp.items.otvalues.length>0)
						{
							var tmpArr	= [],
								tmpModel	= null;
							resp.items	= resp.items.otvalues.setKeys(resp.items.otkeys, function(itm){
								tmpModel	= new _this.ClientContentModel(itm, self);
								if (_this.CID == tmpModel.client_id())
								{
									flag0	= true;
									self.selectedItem(tmpModel);
								}
								tmpArr.push(tmpModel);
							});
							self.items(tmpArr);
						}
						if(active == 1)
						{
							self.archive_count(resp.archive_count);
						}
						else
						{
							self.active_count(resp.active_count);
						}
						self.active(active);

						_this.list_container.masonry('reload');

						if (Otime.Menu.is_new)
						{
							self.addItem();
							Otime.Menu.is_new	= null;
						}

						if (flag0)
						{
							flag0	= false;
							Otime.CID=0;
							self.editItem(self.selectedItem());
						}
					}
				}));
				return true;
			};
		};

		_this.IsValid	= function(item){
			if (item.client_name.isValid() && item.contacts().length > 0)
			{
				var value = false;
				$.each(item.contacts(), function(key, val) {
					if (val.client_contact_id() > 0 && (val.name.isValid() == false || val.email.isValid() == false) && (val.email().lastIndexOf('.') === -1 || val.email().lastIndexOf('.') + 3 != val.email().length - 1))
					{
						value = false;
						return false;
					}
					else if (val.client_contact_id() == '' && val.email.isValid() == false)
					{
						value = false;
						return false;
					}
					else
					{
						value = true;
						return true;
					}
				});
				if (!value)
				{
					alert("Invalid Input, please check.");
					return false;
				}
			}
			return true;
		};

		_this.deletedContacts	= [];

		_this.prepareData	= function(self){
			self.client_code_format(self.client_code() + ' - ');
			var copy	= JSON.parse(ko.toJSON(self));
			delete copy._info;
			copy.deleted_contacts = [];
			var contacts = [];
			var ct;

			$.each(self.contacts(), function(key, ct){
				if (ct._destroy == true)
				{
					copy.deleted_contacts.push(ct.client_contact_id());
					_this.deletedContacts.push(ct);
				}

				if (ct.isDirty() === true && $.trim(ct.name()) != "")
				{
					contacts.push(ct);
				}
			});
			delete copy.contacts;
			copy.contacts = contacts;

			return copy;
		};

		_this.Save	= function(){
			var targetItem	= _this.listModel.popupItem();

			if (!_this.IsValid(targetItem))
			{
				return false;
			}

			if (targetItem.contacts()[0].name() == '')
			{
				alert("Atleast 1 contact needed");
				return false;
			}

			var isNew	= (targetItem.client_id() <= 0);

			var postData	= _this.prepareData(targetItem);

			Otime.app.postData(new Otime.ContextModel({
				url: "save",
				global: true,
				data: postData,
				callback: function(cont){
					var response = cont.response;
					var srcItem	= _this.listModel.popupItem();
					var desItem	= _this.listModel.selectedItem();

					srcItem.client_id(response.client_id);
					if (isNew == true)
					{
						_this.listModel.items.unshift(srcItem);
					}

					if (_this.deletedContacts.length > 0)
					{
						$.each(_this.deletedContacts, function(key, val){
							srcItem.contacts.remove(val);
						});
						_this.deletedContacts	= [];
					}

					srcItem._info.total_contacts(srcItem.contacts().length - 1);

					srcItem.client_name((srcItem.client_code() ? srcItem.client_code()+" - " : "") + srcItem.client_name());

					srcItem.commit();
					srcItem.swapMode();

					desItem.client_name(srcItem.client_name());
					desItem.client_id(srcItem.client_id());
					desItem.title(srcItem.title());
					desItem.client_code(srcItem.client_code());
					desItem.address(srcItem.address());
					desItem.contacts(srcItem.contacts());
					desItem.bg_color(srcItem.bg_color());

					var keys	= Object.keys(desItem._info);
					for (var i=0; i<keys.length; i++)
					{
						desItem._info[keys[i]](srcItem._info[keys[i]]());
					}

					_this.list_container.masonry('reload');
					Otime.Menu.ReplaceURL(_this.name);
				}
			}));
		};

		_this.ClientContentModel	= function(data, parent){
			var self	= this;

			data = data || {};

			var language	= data.language || _this.language;

			self.client_id		= Otime.o(data.client_id || 0);
			self.client_name	= Otime.o(data.client_name || "").extend({ "required": language["CLIENT_NAME_CANT_EMPTY"] || "Client name can't be empty." });
			self.title			= Otime.o(data.title || "");
			self.client_code_format = Otime.o((data.client_code) ? $.trim(data.client_code) : '');
			data.client_code	= (data.client_code) ? $.trim(data.client_code.replace('-', '')) : '';
			self.client_code	= Otime.o(data.client_code);
			self.actual_value	= Otime.o(data.actual_value-0);
			self.budget_value	= Otime.o(data.budget_value-0);
			self.is_active		= Otime.o(data.is_active || 1);
			self.address		= Otime.o(data.address || "");
			self.contacts		= Otime.a([]);
			self.bg_color		= Otime.o(data.bg_color || Otime.bgpicker_colors[Math.floor(Math.random()*Otime.bgpicker_colors.length)]);
			
			data.info = data.info || {};

			var ct = [];
			if (data.contacts && Object.keys(data.contacts).length == 2 && Object.keys(data.contacts.otvalues).length > 0)
			{
				data.contacts = data.contacts.otvalues.setKeys(data.contacts.otkeys, function(val){
					val.language	= language;
					ct.push(new _this.ContactsModel(val));
				});
			}
			ct.push(new _this.ContactsModel({language:language}));
			self.contacts(ct);

			self._info	= {
				active_projects: Otime.o(data.info.active_projects || 0),
				projects_count: Otime.o(data.info.active_projects || 0),
				unpaid_invoice: Otime.o(data.info.unpaid_invoice || 0),
				all_invoice: Otime.o(data.info.all_invoice || 0),
				total_contacts: Otime.o(data.info.total_contacts || 0)
			};

			self.is_show_contact = Otime.o(false);
			self.is_show_loading = Otime.o(false);

			self.addcontact	= function() {
				self.contacts.push(new _this.ContactsModel({language:language}));
			};

			self.set_contacts	= function(context){
				var data	= context.response;

				if (Object.keys(data).length > 0)
				{
					var ct = [];

					$.each(data, function(key, val) {
						val.language	= language;
						ct.push(new _this.ContactsModel(val));
					});

					self.contacts(ct);
				}
			};

			self.removeContact	= function(cont){
				if (cont.client_contact_id() > 0)
				{
					self.contacts.destroy(cont);
				}
				else
				{
					self.contacts.remove(cont);
				}
			};

			self.loadInfo = function(){
				if (self.client_id() > 0)
				{
					Otime.app.loadData(new Otime.ContextModel({
						url: "info/" + self.client_id(),
						global: false,
						callback: function(context){
							var data	= context.response;

							data.projects_count && self._info.projects_count(data.projects_count);
							data.unpaid_invoice && self._info.unpaid_invoice(data.unpaid_invoice);
							data.all_invoice && self._info.all_invoice(data.all_invoice);
						}
					}));
				}
			};

			self.add_new_contact	= function(index){
				return function(item){
					if (index == self.contacts().length - 1 && $.trim(item.name()) != "")
					{
						self.contacts.push(new _this.ContactsModel({language:language}));
					}
				};
			};

			self.getParent	= function(){
				return parent;
			};

			self.save	= _this.Save;

			self.cancel	= function(item){
				self.rollback && self.rollback();
				self.client_name((self.client_code()?self.client_code()+" - ":"")+self.client_name());
				self.swapMode();
				Otime.Menu.ReplaceURL(_this.name);
			};

			self.swapMode	= function() {
				parent.is_edit_mode(false);
				parent.selectedItem(new _this.ClientContentModel());
				_this.list_container.masonry('reload');
			};
		};

		_this.ContactsModel	= function(data){
			var self = this;

			data	= data || {};

			var language	= data.language || _this.language;
			self.client_contact_id	= Otime.o(data.client_contact_id || 0);
			self.address_id	= Otime.o(data.address_id || 0);
			self.name		= Otime.o(data.name || "").extend({ required: language["DELETE_CLIENT_CONFIRM_MSG"] || "Are you sure, you want to delete this contact.", trackChange: true });
			self.title		= Otime.o(data.title || "").extend({ trackChange: true });
			self.email		= Otime.o(data.email || "").extend({ email: language["INVALID_EMAIL"] || "Invalid Email", trackChange: true });
			self.workphone	= Otime.o(data.workphone || "").extend({ trackChange: true });
			self.mobile		= Otime.o(data.mobile || "").extend({ trackChange: true });

			self.isDirty	= Otime.c(function(){
				for (var key in self)
				{
					// Otime.i	= ko.isObservable();
					if (self.hasOwnProperty(key) && Otime.i(self[key]) && typeof self[key].isDirty === 'function' && self[key].isDirty())
					{
						return true;
					}
				}
			});
		};

		_this.UpdateContainers	= function(){
			_this.client_container	= $("#clientcontainer");
			_this.list_container	= $("#list-container");
			_this.edit_container	= $("#edit_layout");
			_this.add_container		= $("#edit_layout");
		};

		_this.loadTemplates	= function(clbk){
			var url	= Otime.siteUrl + '/clients/tmpl';
			$.get(url, {
				v: Otime.version,
				r: Otime.usr
			}, function(content){
				$("#main-container").append(content);
				typeof clbk === 'function' && clbk();
			});
		};

		_this.init	= function(){
			_this.UpdateContainers();
			Otime.unbind();

			_this.list_container.masonry({ itemSelector: '.metro-item', columnWidth: 0 });
			_this.listModel	= new _this.ClientListModel();
			_this.listModel.refresh(_this.listModel.active());
			ko.applyBindings(_this.listModel, _this.client_container.get(0));
		};
	};
}(window.Otime));
